# Returns the 64-bit integer type in C, either "long" or "long long"
function(find_64bit_int_type RESULT_VARIABLE)
    include(CheckTypeSize)
    if (NOT INTEGER_TYPE_64)
        CHECK_TYPE_SIZE("long" _size_res_l BUILTIN_TYPES_ONLY LANGUAGE C)
        if (_size_res_l EQUAL 8)
            message(STATUS "64-bit long")
            set(INTEGER_TYPE_64 "long")
        endif()
    endif()
    if (NOT INTEGER_TYPE_64)
        CHECK_TYPE_SIZE("long long" _size_res_ll BUILTIN_TYPES_ONLY LANGUAGE C)
        if (_size_res_ll EQUAL 8)
            message(STATUS "64-bit long long")
            set(INTEGER_TYPE_64 "long long")
        endif()
    endif()
    if (NOT INTEGER_TYPE_64)
        message(FATAL_ERROR
            "Unable to determine 64-bit integer type to use for SuiteSparse")
    endif()
    set(${RESULT_VARIABLE} ${INTEGER_TYPE_64} PARENT_SCOPE)
endfunction()